aboutsummaryrefslogtreecommitdiffstats
path: root/vnfs/vLB
diff options
context:
space:
mode:
authorMarco Platania <platania@research.att.com>2017-05-15 17:26:06 -0400
committerMarco Platania <platania@research.att.com>2017-05-15 17:26:06 -0400
commitbf325d77199a0e52f195f5304b784bb03a69a07f (patch)
treee44e80eda06dda8aa4178c710c3f9f566f26c93d /vnfs/vLB
parent1a532cd64a16a0186513c7ca2d78951294ca5c36 (diff)
Add templates and config for vLB in OpenStack
Change-Id: Iea69a49b3dc6739a5ee003d61a31e935c9f26476 Signed-off-by: Marco Platania <platania@research.att.com>
Diffstat (limited to 'vnfs/vLB')
-rw-r--r--vnfs/vLB/scripts/set_gre_tunnel.sh5
-rw-r--r--vnfs/vLB/scripts/v_dns_install.sh14
-rwxr-xr-xvnfs/vLB/scripts/v_lb_init.sh28
-rw-r--r--vnfs/vLB/scripts/v_lb_install.sh21
-rw-r--r--vnfs/vLB/scripts/v_packetgen_for_dns_demo_init.sh44
-rw-r--r--vnfs/vLB/scripts/v_packetgen_install.sh1
6 files changed, 97 insertions, 16 deletions
diff --git a/vnfs/vLB/scripts/set_gre_tunnel.sh b/vnfs/vLB/scripts/set_gre_tunnel.sh
index 2fa6c64e..aaad66c1 100644
--- a/vnfs/vLB/scripts/set_gre_tunnel.sh
+++ b/vnfs/vLB/scripts/set_gre_tunnel.sh
@@ -9,13 +9,14 @@ fi
LB_PUBLIC_IP=$1
LB_PRIVATE_IP=$(cat /opt/config/lb_private_ipaddr.txt)
MY_PRIVATE_IP=$(cat /opt/config/local_private_ipaddr.txt)
+OLD_GW=$(route -n | grep "^0.0.0.0" | awk '{print $2}')
sed -i "s/x.x.x.x/"$LB_PUBLIC_IP"/g" /etc/bind/named.conf.options
ip tunnel add gre123 mode gre remote $LB_PRIVATE_IP local $MY_PRIVATE_IP ttl 255
ip link set gre123 up
-ip addr add $LB_PUBLIC_IP"/24" dev gre123
-ifconfig eth0 down
+ip addr add $LB_PUBLIC_IP"/32" dev gre123
+route del default gw $OLD_GW
route add default dev gre123
service bind9 restart
diff --git a/vnfs/vLB/scripts/v_dns_install.sh b/vnfs/vLB/scripts/v_dns_install.sh
index be2c5ed3..5e1d55bf 100644
--- a/vnfs/vLB/scripts/v_dns_install.sh
+++ b/vnfs/vLB/scripts/v_dns_install.sh
@@ -6,6 +6,20 @@ DEMO_ARTIFACTS_VERSION=$(cat /opt/config/demo_artifacts_version.txt)
INSTALL_SCRIPT_VERSION=$(cat /opt/config/install_script_version.txt)
CLOUD_ENV=$(cat /opt/config/cloud_env.txt)
+# OpenStack network configuration
+if [[ $CLOUD_ENV == "openstack" ]]
+then
+ echo 127.0.0.1 $(hostname) >> /etc/hosts
+
+ VDNS_PRIVATE_IP_O=$(cat /opt/config/local_private_ipaddr.txt)
+ echo "auto eth1" >> /etc/network/interfaces
+ echo "iface eth1 inet static" >> /etc/network/interfaces
+ echo " address $VDNS_PRIVATE_IP_O" >> /etc/network/interfaces
+ echo " netmask 255.255.255.0" >> /etc/network/interfaces
+
+ ifup eth1
+fi
+
# Download required dependencies
add-apt-repository -y ppa:openjdk-r/ppa
apt-get update
diff --git a/vnfs/vLB/scripts/v_lb_init.sh b/vnfs/vLB/scripts/v_lb_init.sh
index d130c1ec..e41c4ef3 100755
--- a/vnfs/vLB/scripts/v_lb_init.sh
+++ b/vnfs/vLB/scripts/v_lb_init.sh
@@ -4,6 +4,30 @@
start vpp
sleep 1
+# Compute the network CIDR from the Netmask
+mask2cidr() {
+ nbits=0
+ IFS=.
+ for dec in $1 ; do
+ case $dec in
+ 255) let nbits+=8;;
+ 254) let nbits+=7;;
+ 252) let nbits+=6;;
+ 248) let nbits+=5;;
+ 240) let nbits+=4;;
+ 224) let nbits+=3;;
+ 192) let nbits+=2;;
+ 128) let nbits+=1;;
+ 0);;
+ *) echo "Error: $dec is not recognized"; exit 1
+ esac
+ done
+ echo "$nbits"
+}
+
+IPADDR1_MASK=$(ifconfig eth0 | grep "Mask" | awk '{print $4}' | awk -F ":" '{print $2}')
+IPADDR1_CIDR=$(mask2cidr $IPADDR1_MASK)
+
# Configure VPP for vPacketGenerator
IPADDR1=$(ifconfig eth0 | grep "inet addr" | tr -s ' ' | cut -d' ' -f3 | cut -d':' -f2)
IPADDR2=$(ifconfig eth1 | grep "inet addr" | tr -s ' ' | cut -d' ' -f3 | cut -d':' -f2)
@@ -11,14 +35,14 @@ HWADDR1=$(ifconfig eth0 | grep HWaddr | tr -s ' ' | cut -d' ' -f5)
HWADDR2=$(ifconfig eth1 | grep HWaddr | tr -s ' ' | cut -d' ' -f5)
FAKE_HWADDR1=$(echo -n 00; dd bs=1 count=5 if=/dev/urandom 2>/dev/null |hexdump -v -e '/1 ":%02X"')
FAKE_HWADDR2=$(echo -n 00; dd bs=1 count=5 if=/dev/urandom 2>/dev/null |hexdump -v -e '/1 ":%02X"')
-GW=$(route | grep default | awk '{print $2}')
+GW=$(route -n | grep "^0.0.0.0" | awk '{print $2}')
ifconfig eth0 down
ifconfig eth0 hw ether $FAKE_HWADDR1
ip addr flush dev eth0
ifconfig eth0 up
vppctl tap connect tappub hwaddr $HWADDR1
-vppctl set int ip address tap-0 $IPADDR1"/24"
+vppctl set int ip address tap-0 $IPADDR1"/"$IPADDR1_CIDR
vppctl set int state tap-0 up
brctl addbr br0
brctl addif br0 tappub
diff --git a/vnfs/vLB/scripts/v_lb_install.sh b/vnfs/vLB/scripts/v_lb_install.sh
index 5b84f21e..8bfe9fcd 100644
--- a/vnfs/vLB/scripts/v_lb_install.sh
+++ b/vnfs/vLB/scripts/v_lb_install.sh
@@ -6,6 +6,27 @@ DEMO_ARTIFACTS_VERSION=$(cat /opt/config/demo_artifacts_version.txt)
INSTALL_SCRIPT_VERSION=$(cat /opt/config/install_script_version.txt)
CLOUD_ENV=$(cat /opt/config/cloud_env.txt)
+# OpenStack network configuration
+if [[ $CLOUD_ENV == "openstack" ]]
+then
+ echo 127.0.0.1 $(hostname) >> /etc/hosts
+
+ VLB_PRIVATE_IP_O=$(cat /opt/config/local_private_ipaddr.txt)
+ echo "auto eth1" >> /etc/network/interfaces
+ echo "iface eth1 inet static" >> /etc/network/interfaces
+ echo " address $VLB_PRIVATE_IP_O" >> /etc/network/interfaces
+ echo " netmask 255.255.255.0" >> /etc/network/interfaces
+
+ VLB_PRIVATE_IP_1=$(cat /opt/config/oam_private_ipaddr.txt)
+ echo "auto eth2" >> /etc/network/interfaces
+ echo "iface eth2 inet static" >> /etc/network/interfaces
+ echo " address $VLB_PRIVATE_IP_1" >> /etc/network/interfaces
+ echo " netmask 255.255.255.0" >> /etc/network/interfaces
+
+ ifup eth1
+ ifup eth2
+fi
+
# Download required dependencies
add-apt-repository -y ppa:openjdk-r/ppa
apt-get update
diff --git a/vnfs/vLB/scripts/v_packetgen_for_dns_demo_init.sh b/vnfs/vLB/scripts/v_packetgen_for_dns_demo_init.sh
index 0968b5fa..9e7879bc 100644
--- a/vnfs/vLB/scripts/v_packetgen_for_dns_demo_init.sh
+++ b/vnfs/vLB/scripts/v_packetgen_for_dns_demo_init.sh
@@ -4,19 +4,43 @@
start vpp
sleep 1
+# Compute the network CIDR from the Netmask
+mask2cidr() {
+ nbits=0
+ IFS=.
+ for dec in $1 ; do
+ case $dec in
+ 255) let nbits+=8;;
+ 254) let nbits+=7;;
+ 252) let nbits+=6;;
+ 248) let nbits+=5;;
+ 240) let nbits+=4;;
+ 224) let nbits+=3;;
+ 192) let nbits+=2;;
+ 128) let nbits+=1;;
+ 0);;
+ *) echo "Error: $dec is not recognized"; exit 1
+ esac
+ done
+ echo "$nbits"
+}
+
+IPADDR1_MASK=$(ifconfig eth0 | grep "Mask" | awk '{print $4}' | awk -F ":" '{print $2}')
+IPADDR1_CIDR=$(mask2cidr $IPADDR1_MASK)
+
# Configure VPP for vPacketGenerator
IPADDR1=$(ifconfig eth0 | grep "inet addr" | tr -s ' ' | cut -d' ' -f3 | cut -d':' -f2)
HWADDR1=$(ifconfig eth0 | grep HWaddr | tr -s ' ' | cut -d' ' -f5)
FAKE_HWADDR1=$(echo -n 00; dd bs=1 count=5 if=/dev/urandom 2>/dev/null | hexdump -v -e '/1 ":%02X"')
VLB_IPADDR=$(cat /opt/config/vlb_ipaddr.txt)
-GW=$(route | grep default | awk '{print $2}')
+GW=$(route -n | grep "^0.0.0.0" | awk '{print $2}')
ifconfig eth0 down
ifconfig eth0 hw ether $FAKE_HWADDR1
ip addr flush dev eth0
ifconfig eth0 up
vppctl tap connect tap111 hwaddr $HWADDR1
-vppctl set int ip address tap-0 $IPADDR1"/24"
+vppctl set int ip address tap-0 $IPADDR1"/"$IPADDR1_CIDR
vppctl set int state tap-0 up
brctl addbr br0
brctl addif br0 tap111
@@ -26,9 +50,9 @@ vppctl ip route add 0.0.0.0/0 via $GW
sleep 1
-#Let's set br0 with public IP and valid MAC so that Linux will have public network access
+# Set br0 with public IP and valid MAC so that Linux will have public network access
ifconfig br0 hw ether $HWADDR1
-ifconfig br0 $IPADDR1 netmask 255.255.255.0
+ifconfig br0 $IPADDR1 netmask $IPADDR1_MASK
route add default gw $GW
#Adding static arp entry for VPP so that it will be able to send packets to default GW
@@ -38,15 +62,15 @@ sleep 3
GW_MAC=$(arp -n | grep -w $GW | tr -s ' ' | cut -d' ' -f3)
VLB_MAC=$(arp -n | grep -w $VLB_IPADDR | tr -s ' ' | cut -d' ' -f3)
-#if VLB in our network, we will use its mac
-if [ ! -z "$VLB_MAC" ]; then
-vppctl set ip arp tap-0 $VLB_IPADDR $VLB_MAC
+# If VLB is in our network, we will use its MAC
+if [ ! -z "$VLB_MAC" ]
+then
+ vppctl set ip arp tap-0 $VLB_IPADDR $VLB_MAC
fi
-# in any case let's add arp entry for default gw
+# Add arp entry for default GW
vppctl set ip arp tap-0 $GW $GW_MAC
-
# Install packet streams
sed -i -e "0,/UDP/ s/UDP:.*/UDP: "$IPADDR1" -> "$VLB_IPADDR"/" /opt/dns_streams/stream_dns1
sed -i -e "0,/UDP/ s/UDP:.*/UDP: "$IPADDR1" -> "$VLB_IPADDR"/" /opt/dns_streams/stream_dns2
@@ -59,8 +83,6 @@ sed -i -e "0,/UDP/ s/UDP:.*/UDP: "$IPADDR1" -> "$VLB_IPADDR"/" /opt/dns_streams/
sed -i -e "0,/UDP/ s/UDP:.*/UDP: "$IPADDR1" -> "$VLB_IPADDR"/" /opt/dns_streams/stream_dns9
sed -i -e "0,/UDP/ s/UDP:.*/UDP: "$IPADDR1" -> "$VLB_IPADDR"/" /opt/dns_streams/stream_dns10
-#sed -i -e "s/.*-> 53.*/ UDP: $RANDOM -> 53/" /opt/dns_streams/stream_dns*
-
sed -i -e "s/.*-> 53.*/ UDP: $RANDOM -> 53/" /opt/dns_streams/stream_dns1
sed -i -e "s/.*-> 53.*/ UDP: $RANDOM -> 53/" /opt/dns_streams/stream_dns2
sed -i -e "s/.*-> 53.*/ UDP: $RANDOM -> 53/" /opt/dns_streams/stream_dns3
diff --git a/vnfs/vLB/scripts/v_packetgen_install.sh b/vnfs/vLB/scripts/v_packetgen_install.sh
index bf08f63e..34503491 100644
--- a/vnfs/vLB/scripts/v_packetgen_install.sh
+++ b/vnfs/vLB/scripts/v_packetgen_install.sh
@@ -4,7 +4,6 @@ REPO_URL_BLOB=$(cat /opt/config/repo_url_blob.txt)
REPO_URL_ARTIFACTS=$(cat /opt/config/repo_url_artifacts.txt)
DEMO_ARTIFACTS_VERSION=$(cat /opt/config/demo_artifacts_version.txt)
INSTALL_SCRIPT_VERSION=$(cat /opt/config/install_script_version.txt)
-CLOUD_ENV=$(cat /opt/config/cloud_env.txt)
# Download required dependencies
add-apt-repository -y ppa:openjdk-r/ppa